--IF RUNNING THIS SCRIPT IN SQL MGMT STUDIO
--1. FROM QUERY MENU, SELECT SQLCMD Mode
--2. UNCOMMENT LINE BELOW AND REPLACE "EN" WITH APPROPRIATE LANGUAGE CODE 
--:setvar languagecode "EN"

declare 
  @v_grid_name VARCHAR(6),
  @v_grid_id NUMERIC(14, 0),
  @v_field_id NUMERIC(14, 0),
  @v_field_id_list VARCHAR(1000),
  @v_grid_key_fields VARCHAR(200),
  @v_dataspy_id NUMERIC(14, 0),
  @sChk nvarchar(1);

-------------------------------------------------------------------------------
-- Set custom grid name
-------------------------------------------------------------------------------

set @v_grid_name = 'AUI001'; 

-------------------------------------------------------------------------------
-- Cleanup existing grid
-------------------------------------------------------------------------------
IF EXISTS (SELECT BOT_FUNCTION FROM r5boilertexts WHERE BOT_FUNCTION = @v_grid_name)
BEGIN
      DELETE FROM r5boilertexts where BOT_FUNCTION = @v_grid_name
END

IF EXISTS (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name)
BEGIN
	DELETE FROM r5queryfield where DQF_DDSPYID in (select DDS_DDSPYID from R5dddataspy where DDS_GRIDID in (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name))
	DELETE FROM R5USEGRIDSYSDEFAULT WHERE USD_GRIDID in (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name)
	DELETE FROM R5dddataspy WHERE DDS_GRIDID in (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name)
	DELETE FROM r5gridfield where GFD_GRIDID in (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name)
	DELETE FROM r5gridparam where gdp_gridid in (select grd_gridid from r5grid where GRD_GRIDNAME = @v_grid_name)	
	DELETE FROM r5grid WHERE GRD_GRIDNAME = @v_grid_name
END

IF EXISTS (SELECT FUN_CODE FROM r5functions WHERE FUN_CODE = @v_grid_name)
BEGIN
	DELETE FROM R5EXTMENULANG WHERE EML_EXTMENU IN (SELECT EMN_CODE FROM R5EXTMENUS WHERE EMN_FUNCTION = @v_grid_name);
	DELETE FROM R5EXTMENUS WHERE EMN_FUNCTION = @v_grid_name;
	DELETE FROM r5functions where FUN_CODE = @v_grid_name;
END

-------------------------------------------------------------------------------
--Insert r5functions
-------------------------------------------------------------------------------
INSERT INTO R5FUNCTIONS (FUN_CODE,FUN_DESC,FUN_CLASS,FUN_SUBTYPE,FUN_FILE,FUN_PUBLIC,FUN_SELECT,FUN_BACKGROUND,FUN_APPLICATION,FUN_DIRSEL,FUN_SYSTEM,FUN_DISPLAYAP,FUN_DISPLAYFT,FUN_POPUPAP,FUN_POPUPFT,FUN_DESCCHANGED,FUN_CLASS_ORG,FUN_LST,FUN_RS,FUN_HDR,FUN_EWSREPORT,FUN_PRDDATASRC,FUN_EWSURLNEW,FUN_REPDISABLED,FUN_ADVREPT,FUN_MEKEY,FUN_EWSBTN)
 VALUES (@v_grid_name,'Receivable Purchase Orders (AM)','WEBD','M','R5MENU','-','?','-','BSUGRD','-','+','-','+','-','-','-','*','+','-','-','-','-','-','-','-','YY','-');

-------------------------------------------------------------------------------
-- Insert r5grid
-------------------------------------------------------------------------------

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_grid_id OUTPUT, 'GRD', '1', @sChk OUTPUT
INSERT INTO R5GRID (GRD_DESC,GRD_GRIDID,GRD_BASEQUERY,GRD_GRIDNAME,GRD_BOTFUNCTION,GRD_PORTLETFLAG,GRD_TAB,GRD_GRIDTYPE,GRD_OPTIMIZERON,GRD_DISTINCT,GRD_COMPLEX,GRD_ACTIVE,GRD_NOSCREENDESIGNER)
 VALUES ('Receivable Purchase Orders (AM)',@v_grid_id,'FROM r5orders o,r5companies c WHERE o.ord_supplier = c.com_code 
AND   o.ord_supplier_org = c.com_org 
AND   o.ord_rstatus = ''A'' ',@v_grid_name,@v_grid_name,'-','+',2,'-','-','-','+','-');

-------------------------------------------------------------------------------
-- Insert r5dddataspy
-------------------------------------------------------------------------------

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_dataspy_id OUTPUT, 'DDS', '1', @sChk OUTPUT
INSERT INTO R5DDDATASPY (DDS_DDSPYNAME,DDS_DDSPYID,DDS_SCOPE,DDS_ORGANIZATION,DDS_CREATEDSTAMP,DDS_FILTERSTRXML,DDS_SORTSTRXML,DDS_OWNER,DDS_GRIDID,DDS_TYPE,DDS_DEFAULTFLAG,DDS_CLIENTROWS,DDS_BOTNAME,DDS_SECURITYDATASPY,DDS_MEKEY)
 VALUES ('All Records',@v_dataspy_id,'-','SOUTHERN',getdate(),'<FILTERABLE />','<SORTABLE />','R5',@v_grid_id,'SD','+',30,'DSNAME','-','YY');

-------------------------------------------------------------------------------
-- Insert the three base r5boilertexts
-- Note: You must also insert a r5boilertext record for each "grid field" (see below)
-------------------------------------------------------------------------------

INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,1,100,0,0,'$(languagecode)','List View','TB','1','LST','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,2,100,0,0,'$(languagecode)','Receivable Purchase Orders (AM)','F','1','UDG_HDRLABEL','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,3,100,0,0,'$(languagecode)','All Records','F','1','DSNAME','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,4,100,0,0,'$(languagecode)','postorecode','F','1','postorecode','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,5,100,0,0,'$(languagecode)','posuppliercode','F','1','posuppliercode','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,6,100,0,0,'$(languagecode)','posupplierorganization','F','1','posupplierorganization','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,7,100,0,0,'$(languagecode)','purchaseordercode','F','1','purchaseordercode','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,8,100,0,0,'$(languagecode)','purchaseorderdescription','F','1','purchaseorderdescription','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,9,100,0,0,'$(languagecode)','purchaseorderorganization','F','1','purchaseorderorganization','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,10,100,0,0,'$(languagecode)','supplierdescription','F','1','supplierdescription','10000',getdate(),'-');
INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_POOL,BOT_CREATED,BOT_CLONED)
 VALUES (@v_grid_name,11,100,0,0,'$(languagecode)','availablelinecount','F','1','availablelinecount','10000',getdate(),'-');

-------------------------------------------------------------------------------
-- Copy the R5BOILERTEXTS for each of the languages in the R5LANGINST
-------------------------------------------------------------------------------

INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_FLD2,BOT_PRTP,BOT_LVCR,BOT_ADLEN,BOT_POOL,BOT_CHANGED,BOT_DISPLAY,BOT_CREATED,BOT_CLONED)
SELECT BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,LIN_CODE,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_FLD2,BOT_PRTP,BOT_LVCR,BOT_ADLEN,BOT_POOL,BOT_CHANGED,BOT_DISPLAY,BOT_CREATED,BOT_CLONED
FROM R5BOILERTEXTS, R5LANGINST
WHERE
BOT_LANG = '$(languagecode)' AND BOT_FUNCTION = @v_grid_name AND lin_code <> '$(languagecode)'

-------------------------------------------------------------------------------
-- Insert r5ddfield, r5gridfield, r5queryfield for each grid field
-------------------------------------------------------------------------------

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'o.ord_store','MIXVARCHAR','R5ORDERS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,4,'TEXT','postorecode','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',1,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'o.ord_supplier','MIXVARCHAR','R5ORDERS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,5,'TEXT','posuppliercode','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',2,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'o.ord_supplier_org','VARCHAR','R5ORDERS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,6,'TEXT','posupplierorganization','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',3,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
set @v_grid_key_fields =  LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'o.ord_code','MIXVARCHAR','R5ORDERS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,7,'TEXT','purchaseordercode','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',4,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'o.ord_desc','MIXVARCHAR','R5ORDERS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,8,'TEXT','purchaseorderdescription','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',5,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
set @v_grid_key_fields =  @v_grid_key_fields + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'o.ord_org','VARCHAR','R5ORDERS');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,9,'TEXT','purchaseorderorganization','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',6,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'c.com_desc','MIXVARCHAR','R5COMPANIES');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,10,'TEXT','supplierdescription','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',7,'LIST');

EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_field_id OUTPUT, 'DDF', '1', @sChk OUTPUT;
set @v_field_id_list = @v_field_id_list + ',' + LTRIM(RTRIM(str(@v_field_id)));
INSERT INTO R5DDFIELD (DDF_FIELDID,DDF_SOURCENAME,DDF_DATATYPE,DDF_TABLENAME)
 VALUES (@v_field_id,'(SELECT  count(ol.orl_order) from r5orderlines ol WHERE ol.orl_order = o.ord_code AND   ol.orl_order_org = o.ord_org AND   ol.orl_rtype in ( ''PS'', ''PD'', ''RE'' ) AND   ol.orl_active = ''+'' AND   0 < (SELECT (ISNULL(ol.orl_ordqty,0)-(ISNULL(ol.orl_recvqty,0)+ISNULL(SUM(ISNULL(dkl_countqty,dkl_recvqty)),0))) FROM r5docklines d WHERE dkl_order = orl_order AND   dkl_order_org = orl_order_org AND dkl_ordline = orl_ordline AND dkl_linerstatus NOT IN(''A'',''C'')))','MIXVARCHAR','');
INSERT INTO R5GRIDFIELD (GFD_FIELDID,GFD_GRIDID,GFD_BOTFUNCTION,GFD_BOTNUMBER,GFD_CONTROLTYPE,GFD_TAGNAME,GFD_FIELDTYPE,GFD_OCCURRENCE,GFD_HEADERLOCATION)
 VALUES (@v_field_id,@v_grid_id,@v_grid_name,11,'TEXT','availablelinecount','n',1,'n');
INSERT INTO R5QUERYFIELD (DQF_DDSPYID,DQF_FIELDID,DQF_COLUMNWIDTH,DQF_COLUMNORDER,DQF_VIEWTYPE)
 VALUES (@v_dataspy_id,@v_field_id,'180',8,'LIST');


-------------------------------------------------------------------------------
-- Insert r5gridparam
-------------------------------------------------------------------------------


-------------------------------------------------------------------------------
-- Setup field keys on r5grid
-------------------------------------------------------------------------------

update r5grid set 
grd_keyfields = @v_grid_key_fields, 
grd_filterablelist = @v_field_id_list,
grd_sortablelist = @v_field_id_list,
grd_displayablelist = @v_field_id_list
where grd_gridid = @v_grid_id;
